/*
jGuard is a security framework based on top of jaas (java authentication and authorization security).
it is written for web applications, to resolve simply, access control problems.
version $Name$
http://sourceforge.net/projects/jguard/

Copyright (C) 2004  Charles GAY

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


jGuard project home page:
http://sourceforge.net/projects/jguard/

*/

package net.sf.jguard.core.authentication.schemes;

import java.security.PermissionCollection;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Map;
import javax.security.auth.callback.Callback;
import javax.security.auth.callback.UnsupportedCallbackException;
import net.sf.jguard.core.authentication.AccessContext;
import net.sf.jguard.core.authentication.AuthenticationException;
import net.sf.jguard.core.authentication.bindings.AuthenticationBindingsFactory;
import net.sf.jguard.core.authorization.permissions.JGPositivePermissionCollection;

/**
 * permits to set Login and password directly. It follows the architecture design,
 * but permits to hook it.
 * @author <a href="mailto:diabolo512@users.sourceforge.net">Charles Gay</a>
 * @since 1.1
 */
public class HookFormSchemeHandler implements AuthenticationSchemeHandler{

    public HookFormSchemeHandler(Map<String,String> parameters,AuthenticationBindingsFactory factory){
        
    }
    
    public String getName() {
        return "HOOK";
    }
    
    
    public void buildChallenge(AccessContext context) throws AuthenticationException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    

    public void authenticationSucceed(AccessContext context) throws AuthenticationException {
        
    }

    public void authenticationFailed(AccessContext context) throws AuthenticationException {
        
    }

    public Collection<Class> getCallbackTypes() {
        return new ArrayList<Class>();
    }

    
    public PermissionCollection getGrantedPermissions() {
        return new JGPositivePermissionCollection();
    }

    public boolean answerToChallenge(AccessContext context) {
        return true;
    }

    public void handleSchemeCallbacks(AccessContext context, List<Callback> cbks) throws UnsupportedCallbackException {
        throw new UnsupportedOperationException("Not supported yet.");
    }

}
